from PyQt6.QtWidgets import QApplication, QWidget, QVBoxLayout, QLabel, QComboBox
import sys

# создаёт виджет выпадающего списка
class labeledComboBoxWidget(QWidget):
    def __init__(self, label: str, list_of_items: list):
        super().__init__()
        self.combobox = QComboBox(self)
        self.label = label
        self.items = list_of_items
        self.value = None
        self.initUI()

    def initUI(self):
        vbox = QVBoxLayout()

        cblabel = QLabel(self.label, self)
        vbox.addWidget(cblabel)


        self.combobox.addItems(self.items)
        self.combobox.currentIndexChanged.connect(self.get_value)
        vbox.addWidget(self.combobox)

        self.setLayout(vbox)
        self.show()

    def save_combobox_value(self):
        self.value = self.combobox.currentText()

    def get_value(self):
        self.save_combobox_value()
        print(f"Chosen number: {self.value}")
        return self.value


if __name__ == '__main__':
    app = QApplication(sys.argv)
    ex = labeledComboBoxWidget("label", ['1', '2', '3', '4'])
    sys.exit(app.exec())
