from PyQt6.QtWidgets import QApplication, QWidget, QVBoxLayout, QLabel, QLineEdit
from PyQt6 import QtGui
import sys

# создаёт поле для ввода с комментарием внутри
class labeledQLineEditor(QWidget):
    def __init__(self, label: str, tp: str):
        super().__init__()
        self.lineedit = None
        self.label = label
        self.type = tp
        self.value = None
        self.format = ""
        match self.type:
            case "int":
                self.format = "Enter int number"
            case "float":
                self.format = "Enter float number"
            case "string":
                self.format = "Enter complex number: 1+2j"
        self.initUI()

    def initUI(self):
        vbox = QVBoxLayout()

        label = QLabel(self.label, self)
        vbox.addWidget(label)

        self.lineedit = QLineEdit(self)
        self.lineedit.setPlaceholderText(self.format)
        
        # не позволяет вводить в поля неправильные значения
        match self.type:
            case "int":
                self.lineedit.setValidator(QtGui.QIntValidator())
            case "float":
                self.lineedit.setValidator(QtGui.QDoubleValidator())

        self.lineedit.returnPressed.connect(self.save_line_edit_value)
        vbox.addWidget(self.lineedit)

        self.setLayout(vbox)
        #self.show()

    def save_line_edit_value(self):
        match self.type:
            case "int":
                self.value = int(self.lineedit.text())
            case "float":
                text = self.lineedit.text()
                text = text.replace(',', '.')
                self.value = float(text)
            case "string":
                self.value = self.lineedit.text().replace(' ','')

        #print(f"Entered: {self.value}, type: {type(self.value)}")

    def get_value(self):
        self.save_line_edit_value()
        return self.value


if __name__ == '__main__':
    app = QApplication(sys.argv)
    ex = labeledQLineEditor("enter N", "float")
    sys.exit(app.exec())
