import json
import socket

path_to_init = "kernels_metadata/init.json"
class IncorrectInput(Exception):
    pass

# создание класса презентера
class Presenter:
    # инициализация
    def __init__(self):
        self.conn = None
        self.listener = None
        self.task_type = None
        self.server_socket = None
        self.client_socket = None
        self.kernel_flag = True
        self.kernel_socket = None

    # создание сокета
    def create_socket(self):
        self.server_socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        self.server_socket.bind(('127.0.0.1', 12345))
        self.server_socket.listen(10)
        print("Создан сокет")

    async def get_data_from_socket(self):
        pass
    
    # подключение к сокету
    def init_session(self):
        self.create_socket()
        print("Ждем подключения ui...")
        self.client_socket, client_address = self.server_socket.accept()
        print(f"Подключен клиент {client_address}")
        data = self.client_socket.recv(1024)
        self.task_type = data.decode()
        self.init_kernel()

    def start_page(self):
        data = self.client_socket.recv(1024)
        self.task_type = data.decode()
        self.init_kernel()

    # чтение init файла, отправка данных для отрисовки на View
    def init_kernel(self):
        match self.task_type:
            case 'transfer_matrix':
                with open(path_to_init, "r") as file:
                    init_data = json.load(file)
                print(f"Presenter получил тип задачи: {self.task_type}")
                input_msg = json.dumps(init_data)
                print("Presenter прочитал init")
                print("Presenter отправляет init на gui")
                self.client_socket.send(bytes(input_msg, encoding='utf-8'))
                input_data_from_socket = self.client_socket.recv(1024)
                print("Presenter отправляет входные данные от gui на ядро")
                input_data = json.loads(input_data_from_socket)
                print(input_data)
                self.start_evaluation(self.task_type, input_data_from_socket)
            case 'close_app':
                self.close_app()
    
    def start_evaluation(self, task_type: str, input_data):
        if task_type == 'transfer_matrix':
            if self.kernel_flag:
                self.kernel_flag = False
                self.kernel_socket, address2 = self.server_socket.accept()
            self.kernel_socket.send(input_data)
            output_data = self.kernel_socket.recv(100000)
            print("Получены выходные данные с ядра")
            self.client_socket.send(output_data)

    def close_app(self):
        print("Вы закрыли приложение! Дальше ничего не будет!")
        self.server_socket.close()
        self.client_socket.close()


if __name__ == "__main__":
    my_object = Presenter()
    my_object.init_session()
