from PyQt6.QtWidgets import QApplication, QWidget, QHBoxLayout
from labeled_qline_widget import labeledQLineEditor
import sys


# создание "статичного списка" из заданных элементов - списка, в который не будет ничего добавляться
class staticQLineEditor(QWidget):
    def __init__(self, num, label_list=None, type_list=None):
        super().__init__()

        if label_list is None:
            label_list = []
        if type_list is None:
            type_list = []
        self.num = num
        self.lineeditor_list = []
        self.value_list = []
        self.label_list = label_list
        self.type_list = type_list
        self.initUI()

    def initUI(self):
        hbox = QHBoxLayout()

        for i in range(self.num):
            lb = self.label_list[i]
            tp = self.type_list[i]
            self.lineeditor_list.append(labeledQLineEditor(lb, tp))
            hbox.addWidget(self.lineeditor_list[i])

        self.setLayout(hbox)
        #self.show()
        #self.save_line_edit_value()

    # сохранение данных, введённых пользователем в ячейки для ввода
    def save_line_edit_value(self):
        val_list = []
        for i in range(self.num):
            val = self.lineeditor_list[i].get_value()
            val_list.append(val)
        self.value_list = val_list
        print(f"we are in static_list_widget, val = {self.value_list}")

    def get_value(self):
        self.save_line_edit_value()
        return self.value_list


if __name__ == '__main__':
    app = QApplication(sys.argv)
    ex = staticQLineEditor(3, ["par1", "par2", "par3"], ["int", "int", "float"])
    sys.exit(app.exec())
