import numpy as np
import json
import socket

time_sleep_2 = 2


def layer_matrix(n_layer, d_layer, wl):
    m = np.zeros((2, 2), 'complex')
    m[0, 0] = np.cos(2 * np.pi * n_layer / wl * d_layer)
    m[0, 1] = (np.sin(2 * np.pi * n_layer / wl * d_layer) / n_layer) * 1j
    m[1, 0] = (np.sin(2 * np.pi * n_layer / wl * d_layer) * n_layer) * 1j
    m[1, 1] = np.cos(2 * np.pi * n_layer / wl * d_layer)
    return m


# построим матрицу переноса через блок
def block_matrix(wl):
    m = layer_matrix(layers_parameters[layers - 1][0], layers_parameters[layers - 1][1], wl)
    for k in reversed(range(layers - 1)):
        m = np.dot(m, layer_matrix(layers_parameters[k][0], layers_parameters[k][1], wl))
        return m


# построим матрицу переноса через всю структуру

def S(wavelen):
    m = np.linalg.matrix_power(block_matrix(wavelen), blocks)
    return m


# построим спектры пропускания и отражения
def main(HOST, PORT):
    print("\033[35m <We are in kernel: model calculation> \033[0m")


    kernel_socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    kernel_socket.connect((HOST, PORT))
    print("\033[35m <Connected to the socket> \033[0m")

    while True:

        received_data = kernel_socket.recv(2048)

        print("data is received")

        input_data = json.loads(received_data)

        n_ext = complex(input_data['n_ext'])

        global layers
        layers = len(input_data['layers_parameters'])
        global blocks
        blocks = input_data['num_of_blocks']

        global layers_parameters
        layers_parameters = []

        for [eps, d] in input_data['layers_parameters']:
            layers_parameters.append([complex(eps), d * 1e-9])

        wl_start = input_data['wl_start']
        wl_stop = input_data['wl_stop']
        output_option = input_data['output_option']

        R = lambda l: abs((S(l)[0][1] * n_ext ** 2 + (S(l)[0][0] - S(l)[1][1]) * n_ext - S(l)[1][0]) / (
                S(l)[0][1] * n_ext ** 2 - (S(l)[0][0] + S(l)[1][1]) * n_ext + S(l)[1][0])) ** 2

        T = lambda l: abs((2 * n_ext) / (S(l)[0][1] * n_ext ** 2 - (S(l)[0][0] + S(l)[1][1]) * n_ext + S(l)[1][0])) ** 2

        wl_data = np.linspace(wl_start, wl_stop, 1001)
        x_data = list(wl_data)
        match output_option:
            case 'R':
                R_data = list(map(R, wl_data * 1e-9))
                output = {'x': x_data, 'y': R_data}
            case 'T':
                T_data = list(map(T, wl_data * 1e-9))
                output = {'x': x_data, 'y': T_data}

        print("Evaluated")
        output_data = json.dumps(output)
        print(f"{output_data}")

        kernel_socket.send(bytes(output_data, encoding='utf-8'))
        print("Data sent")
        break


if __name__ == "__main__":
    main('localhost', 12345)